//$Id: rebuild.js,v 1.9 2008/10/18 18:25:04 silviogutierrez Exp $

var presentationRebuild = presentationRebuild || {};

$(document).ready(function() {
  
  presentationRebuild.settings = Drupal.settings.presentationRebuild;

  $('.presentation-rebuild').click(function() {

    presentationRebuild.beginRebuild(presentationRebuild.getID(this.id));
    return false;
  });

});





/**
 * Get the action from a button using it's CSS.
 *
 */
presentationRebuild.getID = function (css) {
  var index = css.lastIndexOf('-');

  return css.substring(index + 1); 
}





/**
 * Begin the rebuilding process. Loop continuously until there are no more
 * pictures to rebuild. Add a progress bar to keep track of everything.
 *
 */
presentationRebuild.beginRebuild = function(operation) {

  //Figure out which operations were requested.
  if (operation != 'all') {
    var operations = operation;
  }
  else {
    var operations = 'derivatives|#|exif|#|iptc|#|sort';
  }
  
  presentationRebuild.settings.threshold = $('#edit-threshold').val();
  
  //If there's a previous progress bar, remove it.
  $('#progress').remove(); 
  
  //Append the progress bar to the right operation.
  $('#presentation-fieldset-' + operation).append(presentationRebuild.settings.progressBar);
  
  $('.presentation-rebuild').attr('disabled', 'disabled');
  presentationRebuild.rebuild(0, operations);

} 
 
 
 
presentationRebuild.rebuild = function(current, operations) {
  var url = presentationRebuild.settings.rebuildURL + current + '/' + presentationRebuild.settings.threshold;

  $.post(url, {presentation_operations : operations}, function(data) {
    var response = presentation.parseJson(data);
    
    $('#progress > div.percentage').html(response.percentage + '%');
    $('#progress div.filled').css('width', response.percentage + '%');
        
    if (response.status == 'continue') {
      presentationRebuild.rebuild(response.current, operations);
    }
    else {
      $('#progress > div.message').html("Finalizing");
          
      $.get(presentationRebuild.settings.finalizeURL + presentationRebuild.settings.threshold, null, function() {
        $('.presentation-rebuild').attr('disabled', '');
        $('#progress > div.message').html("Rebuilding Complete");       
      });
    }
    
  });  

} 






